package com.tcl.ah.module.serverinfo;

import com.tcl.ah.module.serverinfo.data.ServerInfoIni;

import okhttp3.ResponseBody;
import retrofit2.Call;
import retrofit2.http.GET;
import retrofit2.http.Headers;
import retrofit2.http.Query;
import retrofit2.http.Streaming;

public interface ServerInfoService {
    @GET(ServerInfoIni.PATH)
    @Streaming
    @Headers({
            //"Accept:+json;version=1.0",
            "content-type:application/json;charset=UTF-8",
            "cache-control:no-store,private",
            "Pragma:no-cache"
    })
    public Call<ResponseBody> getConfigInfo(@Query(ServerInfoIni.Params.MAC) String mac, @Query(ServerInfoIni.Params.APP_PACKAGE) String packageName);
}
